/*
 * Copyright Contributors to the fusa-gcc-plugin project
 *
 * SPDX-License-Identifier: LGPL-2.1-or-later
 */
#pragma once

#include <json-c/json.h>
#include <json-c/json_object.h>
#include <json-c/json_util.h>

#include "fusa.hpp"
#include "candidate.hpp"

#include <vector>

using namespace std;

typedef unique_ptr<json_object, decltype(&json_object_put)> _json_object;
#define MAKE_PTR(name, value) name(value, json_object_put);

const int expected_version = 1;

int svector_to_json_array(const vector<string> &v, json_object **out);
int serialize_candidate(const candidate &candidate, json_object **out);
int serialize_output(const candidate::set &apis, string &out);
int deserialize_symbol(json_object *symbol, certified_symbol &out);
int deserialize_symbols(json_object *root, vector<certified_symbol> &symbols);
int load_symbols_from_file(string &file, vector<certified_symbol> &symbols);
