/*
 * Copyright Contributors to the fusa-gcc-plugin project
 *
 * SPDX-License-Identifier: LGPL-2.1-or-later
 */
#pragma once

#include <vector>

#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>

#include "strutils.hpp"

using namespace std;

namespace process {
// sink for unwanted output from a processes
static int DEV_NULL = open("/dev/null", O_WRONLY);

struct result {
  int exit_code;
  vector<string> stdout;
};

struct pipe_link {
  int read;
  int write;
  int status;

  pipe_link() {
    int link[2];
    this->status = pipe(link);
    this->read = link[0];
    this->write = link[1];
  }

  bool ok() { return this->status == 0; }
};

process::result run_command(vector<string> args, bool graceful = true);
} // namespace process
